#
# Copyright (c) 2008-2015 Thierry Florac <tflorac AT ulthar.net>
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#

__docformat__ = 'restructuredtext'


# import standard library

# import interfaces
from pyams_pagelet.interfaces import PageletCreatedEvent

# import packages
from pyams_form.form import AddForm, DialogAddForm, EditForm, DialogEditForm, DisplayForm, DialogDisplayForm
from pyams_zmi.view import AdminView


class AdminAddForm(AdminView, AddForm):
    """Admin add form"""

    def update(self):
        self.request.registry.notify(PageletCreatedEvent(self))
        super(AdminAddForm, self).update()


class AdminDialogAddForm(AdminView, DialogAddForm):
    """Admin dialog add form"""

    def update(self):
        self.request.registry.notify(PageletCreatedEvent(self))
        super(AdminDialogAddForm, self).update()


class AdminEditForm(AdminView, EditForm):
    """Admin edit form"""

    def update(self):
        self.request.registry.notify(PageletCreatedEvent(self))
        super(AdminEditForm, self).update()


class AdminDialogEditForm(AdminView, DialogEditForm):
    """Admin dialog edit form"""

    def update(self):
        self.request.registry.notify(PageletCreatedEvent(self))
        super(AdminDialogEditForm, self).update()


class AdminDisplayForm(AdminView, DisplayForm):
    """Admin dialog display form"""

    def update(self):
        self.request.registry.notify(PageletCreatedEvent(self))
        super(AdminDisplayForm, self).update()


class AdminDialogDisplayForm(AdminView, DialogDisplayForm):
    """Admin dialog display form"""

    def update(self):
        self.request.registry.notify(PageletCreatedEvent(self))
        super(AdminDialogDisplayForm, self).update()
